<?php
/**
 * @package Optimize Database after Deleting Revisions
 * @version 1.1.0
 */
/*
Plugin Name: Change WP Post Type
Plugin URI: http://sunsoftworld.com/
Description: WP post type conversion from post to page and page to post
Author: SunSoft World
Author URI: 'http://sunsoftworld.com/'
Network: True
Version: 1.1.0
*/



///////////Start: Function Declaration ///////////////////////////
function cwpt_get_current_post_type() {
  global $post, $typenow, $current_screen;
	
  //we have a post so we can just get the post type from that
  if ( $post && $post->post_type )
    return $post->post_type;
    
  //check the global $typenow - set in admin.php
  elseif( $typenow )
    return $typenow;
    
  //check the global $current_screen object - set in sceen.php
  elseif( $current_screen && $current_screen->post_type )
    return $current_screen->post_type;
  
  //lastly check the post_type querystring
  elseif( isset( $_REQUEST['post_type'] ) )
    return sanitize_key( $_REQUEST['post_type'] );
	
  //echo "cwpt_get_current_post_type : <br />";
  //we do not know the post type!
  return null;
}

  
  function cwpt_get_current_post_id() {
  global $post, $typenow, $current_screen;
	$post = get_post();
    $post_id= $post->ID;
	return $post_id;
  }
	
function cwpt_set_current_post_type($post_id,$cwpt_post_type) {
	
	global $post, $typenow, $current_screen;
	//$post = get_post();
    //$post_id= $post->ID;
	//echo "cwpt_post_type: ";
	//var_dump($cwpt_post_type);
	//var_dump($post_id);
	
	$changeResult="";
	$changeResult= set_post_type( $post_id, $cwpt_post_type  );
	//var_dump($changeResult);
	if ($changeResult!="") {
     return $cwpt_post_type;
    } 
    else {
     return false;
    }  
	  
  }

function cwpt_post_type_metabox_content() {
//echo cwpt_get_current_post_type();
$post_selected="";
$page_selected="";
$cwpt_current_post_type=cwpt_get_current_post_type();
$cwpt_current_post_id=cwpt_get_current_post_id();

if($cwpt_current_post_type=="post"){
	$post_selected="selected='selected'";
	//var_dump($post_selected);
}
if($cwpt_current_post_type=="page"){	
	$page_selected="selected='selected'";
}
	?>
	<p>Current Post Type: <?php echo $cwpt_current_post_type; ?><br />
	<input type="hidden" name="cwpt_current_post_id" value="<?php echo $cwpt_current_post_id; ?>"/>
	<input type="hidden" name="cwpt_current_post_type" value="<?php echo $cwpt_current_post_type; ?>"/>
	<select name="cwpt_select_post_type"  >
	<option value="post" <?php echo $post_selected ?> >Post</option>
	<option value="page" <?php echo $page_selected ?> >Page</option>
	</select>
	<input type="button" name="" value="Change" onclick="cwpt_js_set_post_type(cwpt_current_post_id.value,cwpt_select_post_type.value,cwpt_current_post_type.value);">
	</p>	
	
	<script type="text/javascript">	
	
	function cwpt_js_set_post_type(cwpt_post_id,cwpt_post_type,cwpt_current_post_type){
		if(cwpt_current_post_type==cwpt_post_type){
			alert("Error! Can't change type "+cwpt_current_post_type+" to "+cwpt_post_type+" ");
			return false;
		}
		else{
		if(!confirm("Do you want to change post type: '"+cwpt_current_post_type+" to "+cwpt_post_type+"'")){
			return false;
		}
		else{
	jQuery.ajax({
    type: "POST",
    url: "#",//"<?php echo plugin_dir_url( __FILE__ ); ?>/change-wp-post-type.php",
    dataType: 'text',
    data: {ajaxFunctionName: 'cwpt_set_current_post_type', arguments: [cwpt_post_id,cwpt_post_type]},

    success: function (obj, textstatus) {
		yourVariable = obj.result;
		console.log(yourVariable);
		/*
                  if( !('error' in obj) ) {
                      yourVariable = obj.result;
					  console.log(obj.result);
                  }
                  else {
                      console.log(obj.error);
                  }
				  */
            },
	  error: function(XMLHttpRequest, textStatus, errorThrown) { 
        alert("Status: " + textStatus); alert("Error: " + errorThrown); 
    }       
}).done(function(response) {
	console.log(response);
	
	
var str = response;
var regex = /responseText:\s*(.*?)\s*;/g;

var matches = [];
while (m = regex.exec(str)) {
  matches.push(m[1]);
}
var responseData = JSON.parse(matches[0]);
console.log(responseData);

if(responseData.statusCode>=1){
  alert("Success: Post type changed");
  window.location.reload(true);
}
else{
	alert("Error: "+responseData.message);
}

 //alert("Post type changed");
		});
		
		}
		}

	
	}
	</script>

	
	<?php
		
}
	
 
 function cwpt_enqueue_scripts_head(){
	  
	wp_enqueue_script( 'cwpt_js_scripts_head', plugin_dir_url( __FILE__ ) . 'assets/js/main.js' );
 
  }
 function cwpt_enqueue_scripts_footer(){
	  
   wp_enqueue_script( 'cwpt_js_scripts_footer', plugin_dir_url( __FILE__ )  . 'assets/js/main.js' );
 
  }
   
///////////End: Function Declaration ///////////////////////////

//add_action( 'wp_head', 'cwpt_enqueue_scripts_head' );

// Add help text to right of screen in a metabox
function cwpt_metabox() {
	if(is_admin()){
		//var_dump("Admin Exist");
    add_meta_box( 'after-title-help', 'Convert Post To Page', 'cwpt_post_type_metabox_content', 'post', 'side', 'high' );
	
	add_meta_box( 'after-title-help', 'Convert Page to Post', 'cwpt_post_type_metabox_content', 'page', 'side', 'high' );
}
}

add_action( 'add_meta_boxes', 'cwpt_metabox' );
add_action( 'wp_enqueue_scripts', 'cwpt_enqueue_scripts_footer' );

 if(!isset($_REQUEST['ajaxFunctionName'])){
  
}
else{
	        switch($_POST['ajaxFunctionName']) {
            case 'cwpt_set_current_post_type':
			//var_dump("PostType Argument1:".$_POST['arguments'][0]);
			$responseText="";
               if( !is_array($_POST['arguments']) || (count($_POST['arguments']) < 2) ) {
                   $aResult['error'] = 'Error in arguments!';
				   $responseText.='{"statusCode":"-1","message":"Error in arguments!","data":""}';
				  // echo "responseText:".$aResult['error'].";";
               }
               else {
                   $data = cwpt_set_current_post_type($_POST['arguments'][0],$_POST['arguments'][1]);
				   //var_dump($aResult['result']);
				   if($data=="" || $data==null || $data=="0"){
				      $responseText.='{"statusCode":"-1","message":"Error changing post type!","data":"'.$data.'"}';
				   }
				   else{
					  $responseText.='{"statusCode":"1","message":"Post Type Changed","data":"'.$data.'"}';
				   
				   }
				   //echo "responseText:".$aResult['result'].";";
               }
			   echo "responseText:".$responseText.";";
			      //var_dump($aResult);
               break;

            default:
               $aResult['error'] = 'Not found function '.$_POST['ajaxFunctionName'].'!';
               break;
			   
			return $aResult;   
        }
}



?>